package cn.wps.moffice.demo.util;

import android.content.Context;
import android.os.RemoteException;


import cn.wps.moffice.demo.R;
import cn.wps.moffice.service.OfficeService;
import cn.wps.moffice.service.app.App;


public class PremiumUtils {

    public static void doPremium(int id, Context context, OfficeService mService, String docPath) {
        try {
            if (mService == null || mService.getApps() == null) {
                return;
            }
            App app = mService.getApps().waitForApp();
            if (app != null)
                switch (id) {
                    case R.id.pic2doc:
                        app.pic2doc(docPath);
                        break;
                    case R.id.pic2ET:
                        app.pic2ET(docPath);
                        break;
                    case R.id.pic2PPT:
                        app.pic2PPT(docPath);
                        break;
                    case R.id.pic2PDF:
                        app.pic2PDF(docPath);
                        break;
                    case R.id.openCameraOcr:
                        app.openCameraOcr();
                        break;
                    case R.id.pdfkit2doc:
                        app.pdfkit2doc(docPath);
                        break;
                    case R.id.pdfkitOcr2Text:
                        app.pdfkitOcr2Text(docPath);
                        break;
                    case R.id.pdfkitSign:
                        app.pdfkitSign(docPath);
                        break;
                    case R.id.pdfkitFileSizeReduce:
                        app.pdfkitFileSizeReduce(docPath);
                        break;
                    case R.id.pdfkitMerge:
                        app.pdfkitMerge(docPath);
                        break;
                    case R.id.pdfkitExtract:
                        app.pdfkitExtract(docPath);
                        break;
                    case R.id.extractFile:
                        app.extractFile(docPath);
                        break;
                    case R.id.mergeFile:
                        app.mergeFile(docPath);
                        break;
                    case R.id.pptPlayRecord:
                        app.pptPlayRecord(docPath);
                        break;
                    case R.id.documentBatchSlim:
                        app.documentBatchSlim();
                        break;
                    case R.id.openCameraDoc:
                        app.openCameraDoc();
                        break;
                    case R.id.openCameraPPT:
                        app.openCameraPPT();
                        break;
                    case R.id.pdfkitAnotation:
                        app.pdfkitAnotation(docPath);
                        break;
                    case R.id.pdfkitDocument2pdf:
                        app.pdfkitDocument2pdf(docPath);
                        break;
                    case R.id.goShareplay:
                        app.goShareplay();
                        break;
                }

        } catch (RemoteException e) {
            e.printStackTrace();
        }
    }


    public static void doAThread(int id, Context context, OfficeService mService, String docPath) {
        new PremiumThread(id, context, mService, docPath).start();
    }


    static class PremiumThread extends Thread {

        private int id;
        private Context context;
        private OfficeService service;
        private String docPath;

        public PremiumThread(int id, Context context, OfficeService service, String docPath) {
            this.id = id;
            this.context = context;
            this.service = service;
            this.docPath = docPath;
        }

        @Override
        public void run() {
            doPremium(id, context, service, docPath);
        }
    }
}
